// InstPrivIoXP.h

#define PRIVEIOXP_PORT_DAEMON "PPortIoD.exe"
#define DRIVER_NAME "PrivIoXP"

BOOL bIsWindowsNT(void);

void ShowErr(char *why);

char *MakePortNamePrivIoXP(
    int nPort,
    char *szDeviceName,
    int nMaxBytes
);

HANDLE OpenPrivIoXP(
    BOOL bVerbose,      // 0: errors only, !=0: lots of diagnostics
    char *szPrefix,     // prefix string for error/diagnostic messages
    BOOL bAutoInstall,  // TRUE: auto-install driver, FALSE: don't try
    int nPort,          // LPT port: 0=any, 1=LPT1, 2=LPT2
    int *nActualPort,   // NULL or returned LPT port (1, 2,...)
    int *nOpenCount,    // NULL or returned device open count (1-n)
    int *nIoBase        // NULL or returned base I/O address of port
);

BOOL UnSetPrivIoXP(void);

BOOL SetPrivIoXP(
    BOOL bVerbose,
    char *szPrefix,
    BOOL bAutoInstall,
    int nPort,          // LPT port: 0=any, 1=LPT1, 2=LPT2
    int *nActualPort,   // NULL or returned LPT port (1, 2,...)
    int *nOpenCount,    // NULL or returned device open count (1-n)
    int *nIoBase,       // NULL or returned base I/O address of port
    DWORD *ioList,     // NULL => grant direct access to all I/O addresses
    int ioListEntries  // number of DWORDs in ioList
);

BOOL MakeFullDriverFileName(
    char *szDriverName,
    char szDriverFileName[],
    int lenDriverFileName
);

void PrintfPrivIoXP(char *Fmt, ...);

char *GetLogPrivIoXP(void);
